/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

#if !MBED_TEST_MODE

#include "mbed.h"        // NOLINT
#include "mbed_trace.h"  // NOLINT
// #include "static_scheduling/bike_system.hpp"
#include "static_scheduling_with_event/bike_system.hpp"
// #include "multi_tasking/bike_system.hpp"

#if defined(MBED_CONF_MBED_TRACE_ENABLE)
#define TRACE_GROUP "MAIN"
#endif  // MBED_CONF_MBED_TRACE_ENAB

int main() {
#if defined(MBED_CONF_MBED_TRACE_ENABLE)
    mbed_trace_init();
#endif

    // static_scheduling::BikeSystem bikeSystem;
    // bikeSystem.start();

    static_scheduling_with_event::BikeSystem bikeSystem;
    bikeSystem.start();

    // multi_tasking::BikeSystem bikeSystem;
    // bikeSystem.start();
}

#endif  // MBED_TEST_MODE
